<?php
/**
 *
 *  Codename: ant-ng - generator of sources.list for apt-distributives
 *  http://alex-w.org.ru/p/antng/
 *
 *  Copyright (c) 2009 Alexander Wolf
 *  Dual licensed under the MIT and GNU LGPL licenses.
 *  http://alex-w.org.ru/p/antng/license
 *
 */

class Security extends Core {
    public function __construct() {
    }

    /**
     * Проверка на валидность целочисленных значений
     *
     * @author Alexander Wolf
     * @category Security
     *
     * @param int $value
     * @return int
     */
    public function checkInt($value) {
        return abs(intval($value));
    }

    /**
     * Обработка строковых переменных
     *
     * @author Alexander Wolf
     * @category Security
     *
     * @param string $value
     * @param byte $mode
     * @return string
     */
    public function checkStr($value, $mode = 0) {
        // mode - 0 -> wrap; mode - 1 -> strip;
        if ($mode == 0) {
            $result = mysql_real_escape_string($value);
        } else {
            $result = stripslashes($value);
        }
        return $result;
    }

    /**
     * генерация хеша пароля
     *
     * @author Alexander Wolf
     * @category Security
     * 
     * @param string $string
     * @return string
     */
    public function encryptStr($string) {
        return md5(md5($string)."-CN-ANT-NG-".sha1($string));
    }

}

?>
